#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics ;

using Syncfusion.Windows.Forms.Tools;

namespace TreeViewAdvDragDrop
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Tools.TreeViewAdv treeViewAdv1;
		// Use the tracker only when you want to support dropping adjacent (above or below) to a node.
		// Otherwise simply listen to the DragOver and DragDrop events and provide/use the DropEffect.
		// When used this tracker will draw indicators above or below a node while dragging an item
		// over the node. The tracker need to be updated as shown below in the DragXXX events.
		private TreeViewAdvDragHighlightTracker treeViewDragHighlightTracker = null;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.treeViewDragHighlightTracker = new TreeViewAdvDragHighlightTracker(this.treeViewAdv1);
			// This event will let you disable certain drop-positions for certain nodes while dragging.
			this.treeViewDragHighlightTracker.QueryAllowedPositionsForNode += 
				new QueryAllowedPositionsEventHandler(this.TreeDragDrop_QueryAllowedPositionsForNode);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(treeViewDragHighlightTracker != null)
				{
					this.treeViewDragHighlightTracker.QueryAllowedPositionsForNode -= 
						new QueryAllowedPositionsEventHandler(this.TreeDragDrop_QueryAllowedPositionsForNode);
					this.treeViewDragHighlightTracker = null;
				}
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo treeNodeAdvStyleInfo1 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv1 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv2 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv3 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv4 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv5 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv6 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv7 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv8 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv9 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv10 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv11 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv12 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv13 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv14 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv15 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv16 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv17 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv18 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv19 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv20 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv21 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv22 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv23 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv24 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv25 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv26 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv27 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv28 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv29 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv30 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv31 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdv treeNodeAdv32 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdv();
			this.treeViewAdv1 = new Syncfusion.Windows.Forms.Tools.TreeViewAdv();
			((System.ComponentModel.ISupportInitialize)(this.treeViewAdv1)).BeginInit();
			this.SuspendLayout();
			// 
			// treeViewAdv1
			// 
			this.treeViewAdv1.AllowDrop = true;
			this.treeViewAdv1.BaseStylePairs.AddRange(new Syncfusion.Windows.Forms.Tools.StyleNamePair[] {
																											 new Syncfusion.Windows.Forms.Tools.StyleNamePair("Standard", treeNodeAdvStyleInfo1)});
			this.treeViewAdv1.BorderColor = System.Drawing.Color.Black;
			this.treeViewAdv1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.treeViewAdv1.Font = new System.Drawing.Font("Verdana", 8F);
			// 
			// treeViewAdv1.HelpTextControl
			// 
			this.treeViewAdv1.HelpTextControl.BackgroundColor = new Syncfusion.Drawing.BrushInfo();
			this.treeViewAdv1.HelpTextControl.Border3DStyle = System.Windows.Forms.Border3DStyle.Sunken;
			this.treeViewAdv1.HelpTextControl.BorderSingle = System.Windows.Forms.ButtonBorderStyle.Solid;
			this.treeViewAdv1.HelpTextControl.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.treeViewAdv1.HelpTextControl.IgnoreKeys = true;
			this.treeViewAdv1.HelpTextControl.Location = new System.Drawing.Point(732, 0);
			this.treeViewAdv1.HelpTextControl.Name = "helpText";
			this.treeViewAdv1.HelpTextControl.RestrictWidth = 0;
			this.treeViewAdv1.HelpTextControl.Size = new System.Drawing.Size(50, 17);
			this.treeViewAdv1.HelpTextControl.TabIndex = 0;
			this.treeViewAdv1.HelpTextControl.Text = "help text";
			this.treeViewAdv1.HelpTextControl.Visible = false;
			this.treeViewAdv1.HorizontalThumbTrack = true;
			this.treeViewAdv1.Indent = 20;
			this.treeViewAdv1.Name = "treeViewAdv1";
			treeNodeAdv1.ExpandedOnce = false;
			treeNodeAdv1.Optioned = true;
			treeNodeAdv1.Tag = "Continent";
			treeNodeAdv1.Text = "North America";
			treeNodeAdv1.TextColor = System.Drawing.Color.Red;
			treeNodeAdv2.ExpandedOnce = false;
			treeNodeAdv2.Tag = "Continent";
			treeNodeAdv2.Text = "South America";
			treeNodeAdv2.TextColor = System.Drawing.Color.Red;
			treeNodeAdv3.ExpandedOnce = false;
			treeNodeAdv3.Tag = "Continent";
			treeNodeAdv3.Text = "Antarctica";
			treeNodeAdv3.TextColor = System.Drawing.Color.Red;
			treeNodeAdv4.ExpandedOnce = false;
			treeNodeAdv4.Tag = "Continent";
			treeNodeAdv4.Text = "Europe";
			treeNodeAdv4.TextColor = System.Drawing.Color.Red;
			treeNodeAdv5.ExpandedOnce = false;
			treeNodeAdv5.Tag = "Continent";
			treeNodeAdv5.Text = "Asia";
			treeNodeAdv5.TextColor = System.Drawing.Color.Red;
			treeNodeAdv6.ExpandedOnce = false;
			treeNodeAdv6.Tag = "Continent";
			treeNodeAdv6.Text = "Africa";
			treeNodeAdv6.TextColor = System.Drawing.Color.Red;
			treeNodeAdv7.ExpandedOnce = false;
			treeNodeAdv7.Tag = "Continent";
			treeNodeAdv7.Text = "Australia";
			treeNodeAdv7.TextColor = System.Drawing.Color.Red;
			treeNodeAdv8.ExpandedOnce = false;
			treeNodeAdv8.Text = "Australia";
			treeNodeAdv9.ExpandedOnce = false;
			treeNodeAdv9.Text = "Austria";
			treeNodeAdv10.ExpandedOnce = false;
			treeNodeAdv10.Text = "Belgium";
			treeNodeAdv11.ExpandedOnce = false;
			treeNodeAdv11.Text = "Brazil";
			treeNodeAdv12.ExpandedOnce = false;
			treeNodeAdv12.Text = "Canada";
			treeNodeAdv13.ExpandedOnce = false;
			treeNodeAdv13.Text = "Denmark";
			treeNodeAdv14.Expanded = true;
			treeNodeAdv14.ExpandedOnce = false;
			treeNodeAdv15.ExpandedOnce = false;
			treeNodeAdv15.Optioned = true;
			treeNodeAdv15.Text = "Node0";
			treeNodeAdv16.ExpandedOnce = false;
			treeNodeAdv16.Text = "Node1";
			treeNodeAdv17.ExpandedOnce = false;
			treeNodeAdv17.Text = "Node2";
			treeNodeAdv14.Nodes.AddRange(new Syncfusion.Windows.Forms.Tools.TreeNodeAdv[] {
																							  treeNodeAdv15,
																							  treeNodeAdv16,
																							  treeNodeAdv17});
			treeNodeAdv14.Text = "Finland";
			treeNodeAdv18.ExpandedOnce = false;
			treeNodeAdv18.Text = "France";
			treeNodeAdv19.ExpandedOnce = false;
			treeNodeAdv19.Text = "Germany";
			treeNodeAdv20.ExpandedOnce = false;
			treeNodeAdv20.Text = "Ireland";
			treeNodeAdv21.ExpandedOnce = false;
			treeNodeAdv21.Text = "Italy";
			treeNodeAdv22.ExpandedOnce = false;
			treeNodeAdv22.Text = "Japan";
			treeNodeAdv23.ExpandedOnce = false;
			treeNodeAdv23.Text = "Mexico";
			treeNodeAdv24.ExpandedOnce = false;
			treeNodeAdv24.Text = "Netherlands";
			treeNodeAdv25.ExpandedOnce = false;
			treeNodeAdv25.Text = "Norway";
			treeNodeAdv26.ExpandedOnce = false;
			treeNodeAdv26.Text = "New Zealand";
			treeNodeAdv27.ExpandedOnce = false;
			treeNodeAdv27.Text = "Portugal";
			treeNodeAdv28.ExpandedOnce = false;
			treeNodeAdv28.Text = "Russia";
			treeNodeAdv29.ExpandedOnce = false;
			treeNodeAdv29.Text = "Spain";
			treeNodeAdv30.ExpandedOnce = false;
			treeNodeAdv30.Text = "Sweden";
			treeNodeAdv31.ExpandedOnce = false;
			treeNodeAdv31.Text = "United Kingdom";
			treeNodeAdv32.ExpandedOnce = false;
			treeNodeAdv32.Text = "United States";
			this.treeViewAdv1.Nodes.AddRange(new Syncfusion.Windows.Forms.Tools.TreeNodeAdv[] {
																								  treeNodeAdv1,
																								  treeNodeAdv2,
																								  treeNodeAdv3,
																								  treeNodeAdv4,
																								  treeNodeAdv5,
																								  treeNodeAdv6,
																								  treeNodeAdv7,
																								  treeNodeAdv8,
																								  treeNodeAdv9,
																								  treeNodeAdv10,
																								  treeNodeAdv11,
																								  treeNodeAdv12,
																								  treeNodeAdv13,
																								  treeNodeAdv14,
																								  treeNodeAdv18,
																								  treeNodeAdv19,
																								  treeNodeAdv20,
																								  treeNodeAdv21,
																								  treeNodeAdv22,
																								  treeNodeAdv23,
																								  treeNodeAdv24,
																								  treeNodeAdv25,
																								  treeNodeAdv26,
																								  treeNodeAdv27,
																								  treeNodeAdv28,
																								  treeNodeAdv29,
																								  treeNodeAdv30,
																								  treeNodeAdv31,
																								  treeNodeAdv32});
			this.treeViewAdv1.PathSeparator = "/";
			this.treeViewAdv1.Size = new System.Drawing.Size(360, 438);
			this.treeViewAdv1.TabIndex = 0;
			this.treeViewAdv1.Text = "treeViewAdv1";
			// 
			// treeViewAdv1.ToolTipControl
			// 
			this.treeViewAdv1.ToolTipControl.BackColor = System.Drawing.SystemColors.Info;
			this.treeViewAdv1.ToolTipControl.BackgroundColor = new Syncfusion.Drawing.BrushInfo();
			this.treeViewAdv1.ToolTipControl.Border3DStyle = System.Windows.Forms.Border3DStyle.Sunken;
			this.treeViewAdv1.ToolTipControl.BorderSingle = System.Windows.Forms.ButtonBorderStyle.Solid;
			this.treeViewAdv1.ToolTipControl.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.treeViewAdv1.ToolTipControl.IgnoreKeys = true;
			this.treeViewAdv1.ToolTipControl.Location = new System.Drawing.Point(642, 0);
			this.treeViewAdv1.ToolTipControl.Name = "toolTip";
			this.treeViewAdv1.ToolTipControl.RestrictWidth = 0;
			this.treeViewAdv1.ToolTipControl.Size = new System.Drawing.Size(41, 17);
			this.treeViewAdv1.ToolTipControl.TabIndex = 1;
			this.treeViewAdv1.ToolTipControl.Text = "toolTip";
			this.treeViewAdv1.ToolTipControl.Visible = false;
			this.treeViewAdv1.VerticalThumbTrack = true;
			this.treeViewAdv1.VScrollPos = 1;
			this.treeViewAdv1.DragOver += new System.Windows.Forms.DragEventHandler(this.treeViewAdv_DragOver);
			this.treeViewAdv1.QueryContinueDrag += new System.Windows.Forms.QueryContinueDragEventHandler(this.treeViewAdv_QueryContinueDrag);
			this.treeViewAdv1.DragLeave += new System.EventHandler(this.treeViewAdv_DragLeave);
			this.treeViewAdv1.DragDrop += new System.Windows.Forms.DragEventHandler(this.treeViewAdv_DragDrop);
			this.treeViewAdv1.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.treeViewAdv_ItemDrag);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(360, 438);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.treeViewAdv1});
			this.MinimumSize = new System.Drawing.Size(50, 300);
			this.Name = "Form1";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "TreeViewAdv Drag Drop";
			((System.ComponentModel.ISupportInitialize)(this.treeViewAdv1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		#region DRAG_DROP_UTILS
		private bool IsContinentNode(TreeNodeAdv node)
		{
			if(node.Tag == null
				|| ("Continent").CompareTo(node.Tag.ToString()) != 0)
			{
				return false;
			}
			else
				return true;
		}
		#endregion DRAG_DROP_UTILS

		#region SOURCE_DRAGDROP_LOGIC
		
		private void treeViewAdv_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{
			TreeViewAdv treeViewAdv = sender as TreeViewAdv;

			// The TreeViewAdv always provides an array of selected nodes.
			TreeNodeAdv[] nodes = e.Item as TreeNodeAdv[];

			// Let us get only the first selected node.
			TreeNodeAdv node = nodes[0];

			// Drag only "country" nodes (non-continent nodes)
			if(!IsContinentNode(node))
			{
				// Only allow move
				DragDropEffects result = treeViewAdv.DoDragDrop(node, DragDropEffects.Move);
			}
		}

		private void treeViewAdv_QueryContinueDrag(object sender, System.Windows.Forms.QueryContinueDragEventArgs e)
		{
			// Cancel draggin when Escape was pressed.
			if(e.EscapePressed)
			{
				e.Action = DragAction.Cancel;
			}
		}
		#endregion SOURCE_DRAGDROP_LOGIC

		#region DEST_DRAGDROP_LOGIC
		// Helps keep track of the node that is being dragged.
		private TreeNodeAdv currentSourceNode;
		private void treeViewAdv_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// Determine drag effects
			bool droppable = true;
			TreeNodeAdv destinationNode = null;
			TreeViewAdv treeView = sender as TreeViewAdv;
			Point ptInTree = treeView.PointToClient(new Point(e.X, e.Y));
			this.currentSourceNode = null;

			// Looking for a single tree node.
			if( e.Data.GetDataPresent(typeof(TreeNodeAdv)))
			{
				// Get the destination and source node.
				destinationNode = treeView.GetNodeAtPoint(ptInTree);
				TreeNodeAdv sourceNode = (TreeNodeAdv) e.Data.GetData(typeof(TreeNodeAdv));
				// Cache this for use later in the TreeDragDrop_QueryAllowedPositionsForNode event handler.
				this.currentSourceNode = sourceNode;
				droppable = this.CanDrop(sourceNode, destinationNode);
			}
			else
				droppable = false;

			if(droppable)
				// If Moving is allowed:
				e.Effect = DragDropEffects.Move;
			else
				e.Effect = DragDropEffects.None;

			// Let the highlight tracker keep track of the current highlight node.
			this.treeViewDragHighlightTracker.SetHighlightNode(destinationNode, ptInTree);
		}
		private bool CanDrop(TreeNodeAdv sourceNode, TreeNodeAdv destinationNode)
		{
			if(// Support drag and drop only within the same tree
				sourceNode.TreeView != this.treeViewAdv1 ||
				// Cannot drop into empty area
				destinationNode == null ||
				// Cannot drop over the source's parent
				destinationNode == sourceNode.Parent ||
				// Or over itself
				destinationNode == sourceNode
				)
				return false;
			else
				return true;
		}
		private void treeViewAdv_DragLeave(object sender, System.EventArgs e)
		{
			// Let the highlight tracker keep track of the current highlight node.
			this.treeViewDragHighlightTracker.ClearHighlightNode();
		}

		private void treeViewAdv_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			TreeViewAdv treeView = sender as TreeViewAdv;

			// Get the destination and source node.

			TreeNodeAdv sourceNode = (TreeNodeAdv) e.Data.GetData(typeof(TreeNodeAdv));
			
			TreeNodeAdv destinationNode = this.treeViewDragHighlightTracker.HighlightNode;
			TreeViewDropPositions dropPosition = this.treeViewDragHighlightTracker.DropPosition;
			// Clear the highlight info in the tracker.
			this.treeViewDragHighlightTracker.ClearHighlightNode();

			this.currentSourceNode = null;

			// Move the source node based on the tracked info.
			if(destinationNode != null)
			{
				switch (dropPosition)
				{
					case TreeViewDropPositions.AboveNode:
						sourceNode.Move(destinationNode, NodePositions.Previous);
						break;
					case TreeViewDropPositions.BelowNode:
						sourceNode.Move(destinationNode, NodePositions.Next);
						break;
					case TreeViewDropPositions.OnNode:
						sourceNode.Move(destinationNode.Nodes);
						destinationNode.Expand();
						break;
				}
			}
			
			treeView.SelectedNode = sourceNode;
		}
		// Specifiy the allowed drop positions for the specified highlight node.
		private void TreeDragDrop_QueryAllowedPositionsForNode(object sender, QueryAllowedPositionsEventArgs e)
		{
			if(!this.IsContinentNode(e.HighlightNode))
			{
				// If this a country node, only allow drop above or below it.

				if(e.HighlightNode != this.currentSourceNode)
					e.AllowedPositions = TreeViewDropPositions.AboveNode | TreeViewDropPositions.BelowNode;
				else
					// Cannot drop beside itself
					e.AllowedPositions = TreeViewDropPositions.None;

				this.treeViewDragHighlightTracker.EdgeSensitivity = e.HighlightNode.Bounds.Height / 2;

				e.ShowSelectionHighlight = false;
			}
			else
			{
				// If this is a continent node allow all drop positions (default behavior).
				this.treeViewDragHighlightTracker.EdgeSensitivity = e.HighlightNode.Bounds.Height / 4;

				e.ShowSelectionHighlight = 
					// Only if the source node is droppable
					this.CanDrop(this.currentSourceNode, e.HighlightNode)
					// and droppable ON the node (not beside it)
					&& e.NewDropPosition == TreeViewDropPositions.OnNode;
			}

		}
		#endregion DEST_DRAGDROP_LOGIC

		
	}
}
